using System;
using System.Collections.Generic;
using FluxShared;
using System.Windows.Forms;

namespace MapPlugin {
	class G : FluxShared.GlobalShared {
		public static cTileMap RecentMap;
		public static LocationPropertiesForm LocPropForm;
		public static long nOpenTime = 0;
		public static TilesForm L12TilesForm;
		public static TilesForm L3TilesForm;
		public static List<SaveRecord[]> SaveRec;
		public static Form MainForm;
		private static int nPlugAddrIndex;
		public static Dictionary<string, int> RecTypeDict;



		public static void Init() {
			nPlugAddrIndex = nRomAddr.Count;
			// Japanese = 0, English = 1, Beta = 2
			nRomAddr.AddRange(new uint[(byte) PlugRomAddr.Count][]);
			SetRomAddr(PlugRomAddr.LocProp, new uint[3] { 0x360000, 0x360000, 0x360000 });
			SetRomAddr(PlugRomAddr.LocTileset, new uint[3] { 0x361C00, 0x361C00, 0x361C00 });
			SetRomAddr(PlugRomAddr.LocL12TilesetPtr, new uint[3] { 0x362220, 0x362220, 0x362220 });
			SetRomAddr(PlugRomAddr.LocPal, new uint[3] { 0x3624C0, 0x3624C0, 0x3624C0 });
			SetRomAddr(PlugRomAddr.LocMap, new uint[3] { 0x361E00, 0x361E00, 0x361E00 });
			SetRomAddr(PlugRomAddr.LocTileAsmL12, new uint[3] { 0x362100, 0x362100, 0x362100 });
			SetRomAddr(PlugRomAddr.LocTileAsmL3, new uint[3] { 0x3621C0, 0x3621C0, 0x3621C0 });

			// Added alphabetically here so it will show up in the export combobox alphabetically
			RecTypeDict = new Dictionary<string, int>((int) RecType.Count);
			RecTypeDict.Add("Location Maps", (int) RecType.LocMap);
			RecTypeDict.Add("Location Palette", (int) RecType.LocPal);
			RecTypeDict.Add("Location Properties", (int) RecType.LocProp);
			RecTypeDict.Add("Location Tile Assembly L12", (int) RecType.LocTileAsmL12);
			RecTypeDict.Add("Location Tile Assembly L3", (int) RecType.LocTileAsmL3);
			RecTypeDict.Add("Location Tiles L12", (int) RecType.LocTilesL12);
			RecTypeDict.Add("Location Tileset", (int) RecType.LocTileset);
		}
		
		
		public static uint GetRomAddr(PlugRomAddr RomAddress) {
			return nRomAddr[(byte) RomAddress + nPlugAddrIndex][nRomType];
		}


		private static void SetRomAddr(PlugRomAddr RomAddress, uint[] nValue) {
			nRomAddr[(byte) RomAddress + nPlugAddrIndex] = nValue;
		}



		public static void GetSimpleRec(SaveRecord[] RecArray, uint nMaxSize, PlugRomAddr nBaseAddr, bool bEmptyRec) {
			ushort i;
			SaveRecord Rec;
			for(i = 0; i < RecArray.Length; i++) {
				RecArray[i] = new SaveRecord();
				Rec = RecArray[i];
				Rec.nMaxSize = nMaxSize;
				Rec.Pointer = new PointerRecord[1];
				Rec.Pointer[0] = new PointerRecord(GetRomAddr(nBaseAddr) + (i * 3));
				Rec.bCompressed = true;
				Rec.bCreateEmpty = bEmptyRec;
				Rec.Get();
			}
		}
	}



	// New stuff must go at end for import file compatibility
	public enum RecType : byte {
		//OWMap,
		LocMap,
		//OWEvent,
		//OWExit,
		//OWMTD,
		LocTileAsmL12,
		//OWTileAsmL12,
		LocTileAsmL3,
		//OWTileAsmL3,
		//LocExits,
		//OWTileProps,
		//Strings,
		//LocEvent,
		//Treasure,
		//Substrings,
		//CustomData,
		LocProp,
		LocTileset,
		LocPal,
		LocTilesL12,
		Count
	}



	public enum PlugRomAddr : byte {
		LocProp,
		LocTileset,
		LocL12TilesetPtr,
		LocPal,
		//Instruments,
		//NLZPatch,
		//DactylPatch,
		LocMap,
		LocTileAsmL12,
		LocTileAsmL3,
		//LocExit,
		//OWPal,
		//OWMap,
		//OWTileAsmL12,
		//OWTileAsmL3,
		//OWExit,
		//LocEvent,
		//OWTileProps,
		//OWProp,
		//OWEvent,
		//OWMTD,
		//MPLoc,
		//MPOW,
		//OWTileset,
		//Substring0,
		//PartyEquip,
		//EnemyNames,
		//Treasure,
		//ItemNames,
		//TechNames,
		//StringSpacing,
		//DactylMap,
		//BlackOmenStory,
		//EpochLastVillage,
		//EpochLastVillage2,
		//GameOverMusic,
		//PartyMenuNpc,
		//PartyMenuMusic,
		//UncompressedEnemy,
		//DoorSound,
		//ChestSound,
		//BattleMusic,
		//EpochHovercraftMusic,
		//EpochUpgradedMusic,
		//Substring12,
		//Substring0OrigAddr,
		Count
	}
}
