using System;
using System.Drawing;
using System.Windows.Forms;
using System.IO;
using System.Security.Cryptography;
using GGRLib;
using WeifenLuo.WinFormsUI.Docking;
using System.Threading;
using System.ComponentModel;
using FluxShared;



namespace MapPlugin{
	public class LocationPropertiesForm : DockContent{
		bool bL3Selected = false;
		public bool bNoUpdate = false;
		public LocationForm ActiveMap;

		private System.Windows.Forms.Label label2;
		public FlatSpin L12TilesetSpin;
		public FlatSpin L3TilesetSpin;
		private System.Windows.Forms.Label label3;
		public GGRLib.FlatCombo FlipHorizCombo;
		private System.Windows.Forms.Label label9;
		public GGRLib.FlatCombo FlipVertCombo;
		public System.Windows.Forms.PictureBox imgL12SelectedTile;
		private System.Windows.Forms.Label label11;
		private System.Windows.Forms.Label label7;
		private System.Windows.Forms.Label label8;
		public GGRLib.FlatCombo OverSpritesCombo;
		public FlatSpin PalShiftSpin;
		public FlatSpin PaletteSpin;
		private System.Windows.Forms.Label label21;
		private System.Windows.Forms.Label label5;
		private System.Windows.Forms.Label sLocationCat;
		public FlatSpin RightSpin;
		private System.Windows.Forms.Label label25;
		public FlatSpin BottomSpin;
		private System.Windows.Forms.Label label4;
		private System.Windows.Forms.Label label24;
		private System.Windows.Forms.Label label20;
		public FlatSpin SubtileSpin;
		public GGRLib.FlatCombo QuadCombo;
		public FlatSpin MapSpin;
		private System.Windows.Forms.Label label6;
		private System.Windows.Forms.Label label14;
		private System.Windows.Forms.Label label10;
		private System.Windows.Forms.Label label22;
		public FlatSpin TopSpin;
		public FlatSpin EventsSpin;
		public FlatSpin LeftSpin;
		private System.Windows.Forms.Label label23;
		private System.Windows.Forms.Label label15;
		private System.Windows.Forms.Label label12;
		public System.Windows.Forms.Panel LocPropPanel;
		public GGRLib.FlatCombo LocationCombo;
		private Label label13;
		private Label label1;
		private Label label16;
		private System.ComponentModel.Container components = null;



		public LocationPropertiesForm(){
			InitializeComponent();
			LocationCombo.SelectedIndexChanged += new EventHandler(OnChangeLocation);
		}



		protected override void Dispose(bool disposing){
			if(disposing){
				if(components != null){
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}



		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent() {
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(LocationPropertiesForm));
			this.LocPropPanel = new System.Windows.Forms.Panel();
			this.label13 = new System.Windows.Forms.Label();
			this.label1 = new System.Windows.Forms.Label();
			this.LocationCombo = new GGRLib.FlatCombo();
			this.label2 = new System.Windows.Forms.Label();
			this.L12TilesetSpin = new GGRLib.FlatSpin();
			this.L3TilesetSpin = new GGRLib.FlatSpin();
			this.label3 = new System.Windows.Forms.Label();
			this.FlipHorizCombo = new GGRLib.FlatCombo();
			this.label9 = new System.Windows.Forms.Label();
			this.FlipVertCombo = new GGRLib.FlatCombo();
			this.imgL12SelectedTile = new System.Windows.Forms.PictureBox();
			this.label11 = new System.Windows.Forms.Label();
			this.label7 = new System.Windows.Forms.Label();
			this.label8 = new System.Windows.Forms.Label();
			this.OverSpritesCombo = new GGRLib.FlatCombo();
			this.PalShiftSpin = new GGRLib.FlatSpin();
			this.PaletteSpin = new GGRLib.FlatSpin();
			this.label21 = new System.Windows.Forms.Label();
			this.label5 = new System.Windows.Forms.Label();
			this.sLocationCat = new System.Windows.Forms.Label();
			this.RightSpin = new GGRLib.FlatSpin();
			this.label25 = new System.Windows.Forms.Label();
			this.BottomSpin = new GGRLib.FlatSpin();
			this.label4 = new System.Windows.Forms.Label();
			this.label24 = new System.Windows.Forms.Label();
			this.label20 = new System.Windows.Forms.Label();
			this.SubtileSpin = new GGRLib.FlatSpin();
			this.QuadCombo = new GGRLib.FlatCombo();
			this.MapSpin = new GGRLib.FlatSpin();
			this.label6 = new System.Windows.Forms.Label();
			this.label14 = new System.Windows.Forms.Label();
			this.label10 = new System.Windows.Forms.Label();
			this.label22 = new System.Windows.Forms.Label();
			this.TopSpin = new GGRLib.FlatSpin();
			this.EventsSpin = new GGRLib.FlatSpin();
			this.LeftSpin = new GGRLib.FlatSpin();
			this.label23 = new System.Windows.Forms.Label();
			this.label15 = new System.Windows.Forms.Label();
			this.label12 = new System.Windows.Forms.Label();
			this.label16 = new System.Windows.Forms.Label();
			this.LocPropPanel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize) (this.L12TilesetSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.L3TilesetSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.imgL12SelectedTile)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.PalShiftSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.PaletteSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.RightSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.BottomSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.SubtileSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.MapSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.TopSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.EventsSpin)).BeginInit();
			((System.ComponentModel.ISupportInitialize) (this.LeftSpin)).BeginInit();
			this.SuspendLayout();
			// 
			// LocPropPanel
			// 
			resources.ApplyResources(this.LocPropPanel, "LocPropPanel");
			this.LocPropPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.LocPropPanel.Controls.Add(this.label16);
			this.LocPropPanel.Controls.Add(this.label13);
			this.LocPropPanel.Controls.Add(this.label1);
			this.LocPropPanel.Controls.Add(this.LocationCombo);
			this.LocPropPanel.Controls.Add(this.label2);
			this.LocPropPanel.Controls.Add(this.L12TilesetSpin);
			this.LocPropPanel.Controls.Add(this.L3TilesetSpin);
			this.LocPropPanel.Controls.Add(this.label3);
			this.LocPropPanel.Controls.Add(this.FlipHorizCombo);
			this.LocPropPanel.Controls.Add(this.label9);
			this.LocPropPanel.Controls.Add(this.FlipVertCombo);
			this.LocPropPanel.Controls.Add(this.imgL12SelectedTile);
			this.LocPropPanel.Controls.Add(this.label11);
			this.LocPropPanel.Controls.Add(this.label7);
			this.LocPropPanel.Controls.Add(this.label8);
			this.LocPropPanel.Controls.Add(this.OverSpritesCombo);
			this.LocPropPanel.Controls.Add(this.PalShiftSpin);
			this.LocPropPanel.Controls.Add(this.PaletteSpin);
			this.LocPropPanel.Controls.Add(this.label21);
			this.LocPropPanel.Controls.Add(this.label5);
			this.LocPropPanel.Controls.Add(this.sLocationCat);
			this.LocPropPanel.Controls.Add(this.RightSpin);
			this.LocPropPanel.Controls.Add(this.label25);
			this.LocPropPanel.Controls.Add(this.BottomSpin);
			this.LocPropPanel.Controls.Add(this.label4);
			this.LocPropPanel.Controls.Add(this.label24);
			this.LocPropPanel.Controls.Add(this.label20);
			this.LocPropPanel.Controls.Add(this.SubtileSpin);
			this.LocPropPanel.Controls.Add(this.QuadCombo);
			this.LocPropPanel.Controls.Add(this.MapSpin);
			this.LocPropPanel.Controls.Add(this.label6);
			this.LocPropPanel.Controls.Add(this.label14);
			this.LocPropPanel.Controls.Add(this.label10);
			this.LocPropPanel.Controls.Add(this.label22);
			this.LocPropPanel.Controls.Add(this.TopSpin);
			this.LocPropPanel.Controls.Add(this.EventsSpin);
			this.LocPropPanel.Controls.Add(this.LeftSpin);
			this.LocPropPanel.Controls.Add(this.label23);
			this.LocPropPanel.Controls.Add(this.label15);
			this.LocPropPanel.Controls.Add(this.label12);
			this.LocPropPanel.Name = "LocPropPanel";
			// 
			// label13
			// 
			this.label13.BackColor = System.Drawing.SystemColors.Window;
			this.label13.ForeColor = System.Drawing.Color.Blue;
			resources.ApplyResources(this.label13, "label13");
			this.label13.Name = "label13";
			// 
			// label1
			// 
			this.label1.BackColor = System.Drawing.SystemColors.Window;
			this.label1.ForeColor = System.Drawing.Color.Blue;
			resources.ApplyResources(this.label1, "label1");
			this.label1.Name = "label1";
			// 
			// LocationCombo
			// 
			this.LocationCombo.DropDownStyle = System.Windows.Forms.ComboBoxStyle.DropDownList;
			this.LocationCombo.DropDownWidth = 360;
			resources.ApplyResources(this.LocationCombo, "LocationCombo");
			this.LocationCombo.Name = "LocationCombo";
			// 
			// label2
			// 
			this.label2.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label2, "label2");
			this.label2.Name = "label2";
			// 
			// L12TilesetSpin
			// 
			this.L12TilesetSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.L12TilesetSpin.Hexadecimal = true;
			resources.ApplyResources(this.L12TilesetSpin, "L12TilesetSpin");
			this.L12TilesetSpin.Maximum = new decimal(new int[] {
            255,
            0,
            0,
            0});
			this.L12TilesetSpin.Name = "L12TilesetSpin";
			this.L12TilesetSpin.ValueChanged += new System.EventHandler(this.OnChangeL12Tileset);
			// 
			// L3TilesetSpin
			// 
			this.L3TilesetSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.L3TilesetSpin.Hexadecimal = true;
			resources.ApplyResources(this.L3TilesetSpin, "L3TilesetSpin");
			this.L3TilesetSpin.Maximum = new decimal(new int[] {
            255,
            0,
            0,
            0});
			this.L3TilesetSpin.Name = "L3TilesetSpin";
			this.L3TilesetSpin.ValueChanged += new System.EventHandler(this.OnChangeL3Tileset);
			// 
			// label3
			// 
			this.label3.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label3, "label3");
			this.label3.Name = "label3";
			// 
			// FlipHorizCombo
			// 
			this.FlipHorizCombo.DropDownWidth = 96;
			resources.ApplyResources(this.FlipHorizCombo, "FlipHorizCombo");
			this.FlipHorizCombo.Items.AddRange(new object[] {
            resources.GetString("FlipHorizCombo.Items"),
            resources.GetString("FlipHorizCombo.Items1")});
			this.FlipHorizCombo.Name = "FlipHorizCombo";
			this.FlipHorizCombo.SelectedIndexChanged += new System.EventHandler(this.OnChangeSubtile);
			// 
			// label9
			// 
			this.label9.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label9, "label9");
			this.label9.Name = "label9";
			// 
			// FlipVertCombo
			// 
			this.FlipVertCombo.DropDownWidth = 96;
			resources.ApplyResources(this.FlipVertCombo, "FlipVertCombo");
			this.FlipVertCombo.Items.AddRange(new object[] {
            resources.GetString("FlipVertCombo.Items"),
            resources.GetString("FlipVertCombo.Items1")});
			this.FlipVertCombo.Name = "FlipVertCombo";
			this.FlipVertCombo.SelectedIndexChanged += new System.EventHandler(this.OnChangeSubtile);
			// 
			// imgL12SelectedTile
			// 
			this.imgL12SelectedTile.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			resources.ApplyResources(this.imgL12SelectedTile, "imgL12SelectedTile");
			this.imgL12SelectedTile.Name = "imgL12SelectedTile";
			this.imgL12SelectedTile.TabStop = false;
			this.imgL12SelectedTile.MouseDown += new System.Windows.Forms.MouseEventHandler(this.OnSelectSubtileAsm);
			// 
			// label11
			// 
			this.label11.BackColor = System.Drawing.SystemColors.Control;
			resources.ApplyResources(this.label11, "label11");
			this.label11.ForeColor = System.Drawing.SystemColors.InactiveCaption;
			this.label11.Name = "label11";
			// 
			// label7
			// 
			this.label7.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label7, "label7");
			this.label7.Name = "label7";
			// 
			// label8
			// 
			this.label8.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label8, "label8");
			this.label8.Name = "label8";
			// 
			// OverSpritesCombo
			// 
			this.OverSpritesCombo.DropDownWidth = 96;
			resources.ApplyResources(this.OverSpritesCombo, "OverSpritesCombo");
			this.OverSpritesCombo.Items.AddRange(new object[] {
            resources.GetString("OverSpritesCombo.Items"),
            resources.GetString("OverSpritesCombo.Items1")});
			this.OverSpritesCombo.Name = "OverSpritesCombo";
			this.OverSpritesCombo.SelectedIndexChanged += new System.EventHandler(this.OnChangeSubtile);
			// 
			// PalShiftSpin
			// 
			this.PalShiftSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.PalShiftSpin.Hexadecimal = true;
			resources.ApplyResources(this.PalShiftSpin, "PalShiftSpin");
			this.PalShiftSpin.Maximum = new decimal(new int[] {
            7,
            0,
            0,
            0});
			this.PalShiftSpin.Name = "PalShiftSpin";
			this.PalShiftSpin.ValueChanged += new System.EventHandler(this.OnChangeSubtile);
			// 
			// PaletteSpin
			// 
			this.PaletteSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.PaletteSpin.Hexadecimal = true;
			resources.ApplyResources(this.PaletteSpin, "PaletteSpin");
			this.PaletteSpin.Maximum = new decimal(new int[] {
            255,
            0,
            0,
            0});
			this.PaletteSpin.Name = "PaletteSpin";
			this.PaletteSpin.ValueChanged += new System.EventHandler(this.OnChangeL12Palette);
			// 
			// label21
			// 
			this.label21.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label21, "label21");
			this.label21.Name = "label21";
			// 
			// label5
			// 
			this.label5.BackColor = System.Drawing.SystemColors.Window;
			this.label5.ForeColor = System.Drawing.Color.Blue;
			resources.ApplyResources(this.label5, "label5");
			this.label5.Name = "label5";
			// 
			// sLocationCat
			// 
			this.sLocationCat.BackColor = System.Drawing.SystemColors.Control;
			resources.ApplyResources(this.sLocationCat, "sLocationCat");
			this.sLocationCat.ForeColor = System.Drawing.SystemColors.InactiveCaption;
			this.sLocationCat.Name = "sLocationCat";
			// 
			// RightSpin
			// 
			this.RightSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.RightSpin.Hexadecimal = true;
			resources.ApplyResources(this.RightSpin, "RightSpin");
			this.RightSpin.Maximum = new decimal(new int[] {
            127,
            0,
            0,
            0});
			this.RightSpin.Name = "RightSpin";
			this.RightSpin.ValueChanged += new System.EventHandler(this.OnChangeScrollMask);
			// 
			// label25
			// 
			this.label25.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label25, "label25");
			this.label25.Name = "label25";
			// 
			// BottomSpin
			// 
			this.BottomSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.BottomSpin.Hexadecimal = true;
			resources.ApplyResources(this.BottomSpin, "BottomSpin");
			this.BottomSpin.Maximum = new decimal(new int[] {
            127,
            0,
            0,
            0});
			this.BottomSpin.Name = "BottomSpin";
			this.BottomSpin.ValueChanged += new System.EventHandler(this.OnChangeScrollMask);
			// 
			// label4
			// 
			this.label4.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label4, "label4");
			this.label4.Name = "label4";
			// 
			// label24
			// 
			this.label24.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label24, "label24");
			this.label24.Name = "label24";
			// 
			// label20
			// 
			this.label20.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label20, "label20");
			this.label20.Name = "label20";
			// 
			// SubtileSpin
			// 
			this.SubtileSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.SubtileSpin.Hexadecimal = true;
			resources.ApplyResources(this.SubtileSpin, "SubtileSpin");
			this.SubtileSpin.Maximum = new decimal(new int[] {
            1023,
            0,
            0,
            0});
			this.SubtileSpin.Name = "SubtileSpin";
			this.SubtileSpin.ValueChanged += new System.EventHandler(this.OnChangeSubtile);
			// 
			// QuadCombo
			// 
			this.QuadCombo.DropDownWidth = 96;
			resources.ApplyResources(this.QuadCombo, "QuadCombo");
			this.QuadCombo.Items.AddRange(new object[] {
            resources.GetString("QuadCombo.Items"),
            resources.GetString("QuadCombo.Items1"),
            resources.GetString("QuadCombo.Items2"),
            resources.GetString("QuadCombo.Items3")});
			this.QuadCombo.Name = "QuadCombo";
			this.QuadCombo.SelectedIndexChanged += new System.EventHandler(this.OnSelectSubtileAsm);
			// 
			// MapSpin
			// 
			this.MapSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.MapSpin.Hexadecimal = true;
			resources.ApplyResources(this.MapSpin, "MapSpin");
			this.MapSpin.Maximum = new decimal(new int[] {
            255,
            0,
            0,
            0});
			this.MapSpin.Name = "MapSpin";
			this.MapSpin.ValueChanged += new System.EventHandler(this.OnChangeMap);
			// 
			// label6
			// 
			this.label6.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label6, "label6");
			this.label6.Name = "label6";
			// 
			// label14
			// 
			this.label14.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label14, "label14");
			this.label14.Name = "label14";
			// 
			// label10
			// 
			this.label10.BackColor = System.Drawing.SystemColors.Control;
			resources.ApplyResources(this.label10, "label10");
			this.label10.ForeColor = System.Drawing.SystemColors.InactiveCaption;
			this.label10.Name = "label10";
			// 
			// label22
			// 
			this.label22.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label22, "label22");
			this.label22.Name = "label22";
			// 
			// TopSpin
			// 
			this.TopSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.TopSpin.Hexadecimal = true;
			resources.ApplyResources(this.TopSpin, "TopSpin");
			this.TopSpin.Maximum = new decimal(new int[] {
            127,
            0,
            0,
            0});
			this.TopSpin.Name = "TopSpin";
			this.TopSpin.ValueChanged += new System.EventHandler(this.OnChangeScrollMask);
			// 
			// EventsSpin
			// 
			this.EventsSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.EventsSpin.Hexadecimal = true;
			resources.ApplyResources(this.EventsSpin, "EventsSpin");
			this.EventsSpin.Maximum = new decimal(new int[] {
            512,
            0,
            0,
            0});
			this.EventsSpin.Name = "EventsSpin";
			this.EventsSpin.ValueChanged += new System.EventHandler(this.OnChangeEvents);
			// 
			// LeftSpin
			// 
			this.LeftSpin.BorderStyle = System.Windows.Forms.BorderStyle.None;
			this.LeftSpin.Hexadecimal = true;
			resources.ApplyResources(this.LeftSpin, "LeftSpin");
			this.LeftSpin.Maximum = new decimal(new int[] {
            128,
            0,
            0,
            0});
			this.LeftSpin.Name = "LeftSpin";
			this.LeftSpin.ValueChanged += new System.EventHandler(this.OnChangeScrollMask);
			// 
			// label23
			// 
			this.label23.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label23, "label23");
			this.label23.Name = "label23";
			// 
			// label15
			// 
			this.label15.BackColor = System.Drawing.SystemColors.Window;
			resources.ApplyResources(this.label15, "label15");
			this.label15.Name = "label15";
			// 
			// label12
			// 
			this.label12.BackColor = System.Drawing.SystemColors.Control;
			resources.ApplyResources(this.label12, "label12");
			this.label12.ForeColor = System.Drawing.SystemColors.InactiveCaption;
			this.label12.Name = "label12";
			// 
			// label16
			// 
			this.label16.BackColor = System.Drawing.SystemColors.Window;
			this.label16.ForeColor = System.Drawing.Color.Blue;
			resources.ApplyResources(this.label16, "label16");
			this.label16.Name = "label16";
			// 
			// LocationPropertiesForm
			// 
			resources.ApplyResources(this, "$this");
			this.Controls.Add(this.LocPropPanel);
			this.DockAreas = ((WeifenLuo.WinFormsUI.Docking.DockAreas) (((WeifenLuo.WinFormsUI.Docking.DockAreas.Float | WeifenLuo.WinFormsUI.Docking.DockAreas.DockLeft)
						| WeifenLuo.WinFormsUI.Docking.DockAreas.DockRight)));
			this.HideOnClose = true;
			this.Name = "LocationPropertiesForm";
			this.ShowHint = WeifenLuo.WinFormsUI.Docking.DockState.DockLeft;
			this.Resize += new System.EventHandler(this.OnResize);
			this.Enter += new System.EventHandler(this.OnFocusEnter);
			this.LocPropPanel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize) (this.L12TilesetSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.L3TilesetSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.imgL12SelectedTile)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.PalShiftSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.PaletteSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.RightSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.BottomSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.SubtileSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.MapSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.TopSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.EventsSpin)).EndInit();
			((System.ComponentModel.ISupportInitialize) (this.LeftSpin)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion



		public void OnChangeLocation(object sender, System.EventArgs e){
			if(ActiveMap != null){
				if(!ActiveMap.bNoUpdate){
					SaveRecord Rec = G.SaveRec[(byte) RecType.LocProp][LocationCombo.SelectedIndex];
					ActiveMap.TabText = "Location - " + LocationCombo.SelectedItem;
					ActiveMap.bNoUpdate = true;
					PaletteSpin.Value = Rec.nData[3];
					L12TilesetSpin.Value = Rec.nData[1];
					ActiveMap.ChangeTileset12();
					L3TilesetSpin.Value = Rec.nData[2];
					ActiveMap.ChangeTileset3();
					MapSpin.Value = Rec.nData[4];
					ActiveMap.ChangeMap();
					EventsSpin.Value = G.GetShort(Rec.nData, 8);
					LeftSpin.Value = Rec.nData[10];
					TopSpin.Value = Rec.nData[11];
					RightSpin.Value = Rec.nData[12];
					BottomSpin.Value = Rec.nData[13];
					ActiveMap.bNoUpdate = false;
					ActiveMap.ChangePalette();
					G.L12TilesForm.SelectTile(0);
				}
			}
		}


		
		private void OnChangeMap(object sender, System.EventArgs e) {
			if(!ActiveMap.bNoUpdate) {
				ActiveMap.ChangeMap();
			}
		}

		
		
		private void OnChangeScrollMask(object sender, System.EventArgs e) {
			ActiveMap.ChangeMask();
		}



		private void OnChangeL12Palette(object sender, System.EventArgs e) {
			ActiveMap.ChangePalette();
		}



		private void OnSelectSubtileAsm(object sender, System.Windows.Forms.MouseEventArgs e) {
			SelectSubtileAsm((byte) (((e.Y & 0x10) >> 3) | (e.X >> 4)));
		}


		
		private void OnChangeEvents(object sender, System.EventArgs e) {
			G.SaveRec[(byte) RecType.LocProp][LocationCombo.SelectedIndex].nData[8] = (byte) ((ushort) EventsSpin.Value & 0xFF);
			G.SaveRec[(byte) RecType.LocProp][LocationCombo.SelectedIndex].nData[9] = (byte) ((ushort) EventsSpin.Value >> 8);
		}



		private void OnChangeL12Tileset(object sender, System.EventArgs e) {
			if(!ActiveMap.bNoUpdate) {
				ActiveMap.ChangeTileset12();
				ActiveMap.TileMap.RedrawMap();
			}
		}



		private void OnChangeL3Tileset(object sender, System.EventArgs e) {
			if(!ActiveMap.bNoUpdate) {
				ActiveMap.ChangeTileset3();
				ActiveMap.TileMap.RedrawMap();
			}
		}



		public void SelectSubtileAsm(byte nSelSubtile){
			bNoUpdate = true;
			ushort nSubtile = 0;
			if(!ActiveMap.mnuLayer[2].Checked || (byte) L3TilesetSpin.Value == 0xFF){
				nSubtile = G.GetShort(ActiveMap.L12TileAsm, (ActiveMap.TileMap.AreaSelected[0][0][0] << 3) + (nSelSubtile << 1));
				bL3Selected = false;
			}
			else{
				nSubtile = G.GetShort(ActiveMap.L3TileAsm, (ActiveMap.TileMap.AreaSelected[0][0][0] << 3) + (nSelSubtile << 1));
				bL3Selected = true;
			}
			SubtileSpin.Value = nSubtile & 0x03FF;
			QuadCombo.SelectedIndex = nSelSubtile;
			OverSpritesCombo.SelectedIndex = (nSubtile & 0x2000) >> 13;
			FlipHorizCombo.SelectedIndex = (nSubtile >> 14) & 0x01;
			FlipVertCombo.SelectedIndex = nSubtile >> 15;
			PalShiftSpin.Value = (nSubtile & 0x1C00) >> 10;
			bNoUpdate = false;
		}



		private void OnChangeSubtile(object sender, System.EventArgs e) {
			if(bNoUpdate || ActiveMap.TileMap.AreaSelected == null){
				return;
			}

			ushort nSubtile = (ushort) SubtileSpin.Value;
			nSubtile |= (ushort) ((byte) PalShiftSpin.Value << 10);
			nSubtile |= (ushort) ((byte) OverSpritesCombo.SelectedIndex << 13);
			nSubtile |= (ushort) ((byte) FlipHorizCombo.SelectedIndex << 14);
			nSubtile |= (ushort) ((byte) FlipVertCombo.SelectedIndex << 15);
			ushort nTile = (ushort) ((ActiveMap.TileMap.AreaSelected[0][0][0] << 3) + (QuadCombo.SelectedIndex << 1));
			try {
				if(!bL3Selected) {
					ActiveMap.L12TileAsm[nTile] = (byte) (nSubtile & 0xFF);
					ActiveMap.L12TileAsm[nTile + 1] = (byte) (nSubtile >> 8);
					G.L12TilesForm.DrawSelectedTile((byte) QuadCombo.SelectedIndex);
					G.SaveRec[(byte) RecType.LocTileAsmL12][(byte) L12TilesetSpin.Value].bModified = true;
				}
				else {
					ActiveMap.L3TileAsm[nTile] = (byte) (nSubtile & 0xFF);
					ActiveMap.L3TileAsm[nTile + 1] = (byte) (nSubtile >> 8);
					G.L3TilesForm.DrawSelectedTile((byte) QuadCombo.SelectedIndex);
					G.SaveRec[(byte) RecType.LocTileAsmL3][(byte) L3TilesetSpin.Value].bModified = true;
				}
				SelectSubtileAsm((byte) QuadCombo.SelectedIndex);

				Cursor.Current = Cursors.WaitCursor;
				ActiveMap.TileMap.UpdateTilesInUse((byte) ActiveMap.TileMap.AreaSelected[0][0][0]);
			}
			catch(IndexOutOfRangeException){
				G.PostStatus("Error: Invalid tilesets");
			}
			Cursor.Current = Cursors.Default;
		}



		private void OnSelectSubtileAsm(object sender, System.EventArgs e) {
			if(!bNoUpdate){
				SelectSubtileAsm((byte) QuadCombo.SelectedIndex);
			}
		}

		private void OnResize(object sender, EventArgs e) {
			int nWidth = ClientRectangle.Width;
			int nHeight = ClientRectangle.Height;

			LocPropPanel.Width = nWidth - 2;
			LocPropPanel.Height = nHeight - 4;
			AutoHidePortion = nWidth;
		}

		private void OnFocusEnter(object sender, EventArgs e) {
			for(int i = 0; i < G.MainForm.MdiChildren.Length; i++) {
				Form ChildForm = G.MainForm.MdiChildren[i];
				if(ChildForm.GetType() == typeof(LocationForm)) {
					((LocationForm) ChildForm).SetDisplayMode(DisplayMode.Normal);
				}
			}
		}
	}
}