using System;
using System.Drawing;
using System.Drawing.Imaging;
using System.Windows.Forms;
using PSVRender;
using WeifenLuo.WinFormsUI.Docking;
using FluxShared;



namespace MapPlugin {
	public class TilesForm : DockContent {
		bool bMouseDown = false;
		public Bitmap bmpTiles;
		ushort nPrevMouseTileX = 0;
		ushort nPrevMouseTileY = 0;
		public byte nTileType;
		PictureBox imgTiles;

		private System.ComponentModel.Container components = null;
		public System.Windows.Forms.Panel TilesPanel;


		public TilesForm() {
			InitializeComponent();
		}

		
		
		protected override void Dispose(bool disposing){
			if(disposing){
				if(components != null){
					components.Dispose();
				}
			}
			base.Dispose(disposing);
		}



		#region Windows Form Designer generated code
		/// <summary>
		/// Required method for Designer support - do not modify
		/// the contents of this method with the code editor.
		/// </summary>
		private void InitializeComponent()
		{
			this.TilesPanel = new System.Windows.Forms.Panel();
			this.imgTiles = new System.Windows.Forms.PictureBox();
			this.TilesPanel.SuspendLayout();
			((System.ComponentModel.ISupportInitialize) (this.imgTiles)).BeginInit();
			this.SuspendLayout();
			// 
			// TilesPanel
			// 
			this.TilesPanel.AutoScroll = true;
			this.TilesPanel.BorderStyle = System.Windows.Forms.BorderStyle.FixedSingle;
			this.TilesPanel.Controls.Add(this.imgTiles);
			this.TilesPanel.Location = new System.Drawing.Point(1, 1);
			this.TilesPanel.Name = "TilesPanel";
			this.TilesPanel.Size = new System.Drawing.Size(264, 520);
			this.TilesPanel.TabIndex = 3;
			// 
			// imgTiles
			// 
			this.imgTiles.BorderStyle = System.Windows.Forms.BorderStyle.Fixed3D;
			this.imgTiles.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
			this.imgTiles.Location = new System.Drawing.Point(1, 1);
			this.imgTiles.Name = "imgTiles";
			this.imgTiles.Size = new System.Drawing.Size(260, 516);
			this.imgTiles.SizeMode = System.Windows.Forms.PictureBoxSizeMode.StretchImage;
			this.imgTiles.TabIndex = 2;
			this.imgTiles.TabStop = false;
			// 
			// TilesForm
			// 
			this.AutoScaleBaseSize = new System.Drawing.Size(5, 14);
			this.ClientSize = new System.Drawing.Size(266, 522);
			this.Controls.Add(this.TilesPanel);
			this.DockAreas = ((WeifenLuo.WinFormsUI.Docking.DockAreas) (((WeifenLuo.WinFormsUI.Docking.DockAreas.Float | WeifenLuo.WinFormsUI.Docking.DockAreas.DockLeft)
						| WeifenLuo.WinFormsUI.Docking.DockAreas.DockRight)));
			this.Font = new System.Drawing.Font("Tahoma", 8.25F, System.Drawing.FontStyle.Regular, System.Drawing.GraphicsUnit.Point, ((byte) (0)));
			this.HideOnClose = true;
			this.Name = "TilesForm";
			this.ShowHint = WeifenLuo.WinFormsUI.Docking.DockState.DockRight;
			this.TabText = "Tiles";
			this.Text = "TilesForm";
			this.Resize += new System.EventHandler(this.OnResize);
			this.TilesPanel.ResumeLayout(false);
			((System.ComponentModel.ISupportInitialize) (this.imgTiles)).EndInit();
			this.ResumeLayout(false);

		}
		#endregion




		public void SelectTile(ushort nTile){
			MouseEventArgs mea = new MouseEventArgs(MouseButtons.Left, 1, ((nTile & 0x07) << 4) * G.nZoomFactor, ((nTile & 0x1F8) << 1) * G.nZoomFactor, 0);
			OnMouseDown(this, mea);
			OnMouseUp(this, mea);
		}
		
		
		
		public void OnMouseUp(object sender, System.Windows.Forms.MouseEventArgs e) {
			MouseEventArgs mea = new MouseEventArgs(e.Button, e.Clicks, e.X / G.nZoomFactor, e.Y / G.nZoomFactor, e.Delta);
			bMouseDown = false;
			if(G.MainForm.ActiveMdiChild != null){
				byte nType = 2;
				if(G.MainForm.ActiveMdiChild.GetType() == typeof(LocationForm)){
					nType = 0;
				}
				//else if(G.MainForm.ActiveMdiChild.GetType() == typeof(OverworldForm)){
				//    nType = 1;
				//}
				if(nType == 2){
					return;
				}

				MapForm LocForm = (MapForm) G.MainForm.ActiveMdiChild;
				cTileMap TileMap = LocForm.TileMap;
				G.RecentMap = TileMap;

				// If L3 is not active
				if(nTileType == 1 && LocForm.L3TileAsm == null){
					TileMap.nCopyAreaSelectY = 1;
					TileMap.nCopyAreaSelectX = 1;
					TileMap.nCopyAreaSelectH = 1;
					TileMap.nCopyAreaSelectW = 1;
					return;
				}

				if(sender != null){
					ushort nMouseTileX = (ushort) (mea.X & 0xFFF0);
					ushort nMouseTileY = (ushort) (mea.Y & 0xFFF0);

					if(nMouseTileX < TileMap.nCopyAreaSelectX){
						TileMap.nCopyAreaSelectX = nMouseTileX;
					}
					if(nMouseTileY < TileMap.nCopyAreaSelectY){
						TileMap.nCopyAreaSelectY = nMouseTileY;
					}

					TileMap.nCopyAreaSelectY >>= 4;
					TileMap.nCopyAreaSelectX >>= 4;
					TileMap.nCopyAreaSelectH >>= 4;
					TileMap.nCopyAreaSelectW >>= 4;

					if(TileMap.nCopyAreaSelectY + TileMap.nCopyAreaSelectH > 0x20){
						TileMap.nCopyAreaSelectH = (ushort) (TileMap.nMaxHeight - TileMap.nCopyAreaSelectY);
					}
					if(TileMap.nCopyAreaSelectX + TileMap.nCopyAreaSelectW > 0x10){
						TileMap.nCopyAreaSelectW = (ushort) (TileMap.nMaxWidth - TileMap.nCopyAreaSelectX);
					}
					
					if(!(TileMap.nCopyAreaSelectH == 0 || TileMap.nCopyAreaSelectH > 64 || TileMap.nCopyAreaSelectW == 0 || TileMap.nCopyAreaSelectW > 64)){
						ushort i;
						byte j;
						for(i = 0; i < 3; i++) {
							TileMap.AreaSelected[i] = new ushort[TileMap.nCopyAreaSelectW][];
							for(j = 0; j < TileMap.nCopyAreaSelectW; j++) {
								TileMap.AreaSelected[i][j] = new ushort[TileMap.nCopyAreaSelectH];
							}
						}

						for(i = 0; i < 3; i++) {
							for(byte y = 0; y < TileMap.nCopyAreaSelectH; y++) {
								for(byte x = 0; x < TileMap.nCopyAreaSelectW; x++) {
									TileMap.AreaSelected[i][x][y] = (ushort) (((y + TileMap.nCopyAreaSelectY) << 4) | (x + TileMap.nCopyAreaSelectX));
								}
							}
						}

						TileMap.AreaTileProp = new byte[TileMap.nCopyAreaSelectW][][];
						for(i = 0; i < TileMap.nCopyAreaSelectW; i++){
							TileMap.AreaTileProp[i] = new byte[TileMap.nCopyAreaSelectH][];
							for(j = 0; j < TileMap.nCopyAreaSelectH; j++){
								TileMap.AreaTileProp[i][j] = new byte[3];
							}
						}
					}
				}

				if(TileMap.nCopyAreaSelectH == 0 || TileMap.nCopyAreaSelectW == 0){
					return;
				}

				DrawSelectedTile(0);

				// Restore image
				imgTiles.Image = bmpTiles.Clone(new System.Drawing.Rectangle(0, 0, bmpTiles.Width, bmpTiles.Height), bmpTiles.PixelFormat);
				GC.Collect();
			}
		}


		
		public void DrawSelectedTile(byte nQuad){
			MapForm LocForm = (MapForm) G.MainForm.ActiveMdiChild;
			cTileMap TileMap = LocForm.TileMap;

			byte nMapType = 2;
			if(LocForm.GetType() == typeof(LocationForm)){
				nMapType = 0;
			}
			//else if(LocForm.GetType() == typeof(OverworldForm)){
			//    nMapType = 1;
			//}
			
			ushort nSubtile;
			Bitmap bmpSelectedTile = new Bitmap(16, 16);
			PutSubtileVar TileChunk = new PutSubtileVar();
			TileChunk.WorkingImage = bmpSelectedTile;
			TileChunk.WorkingPalette = LocForm.LPalette;
			if(nTileType == 0){
				TileChunk.nBitPlanes = BitPlanes.eTetraPlane;
				TileChunk.WorkingBuffer = LocForm.L12SubtileData;
			}
			else{
				TileChunk.nBitPlanes = BitPlanes.eDiPlane;
				TileChunk.WorkingBuffer = LocForm.L3SubtileData;
			}

			unsafe{
				BitmapData WIData = bmpSelectedTile.LockBits(new System.Drawing.Rectangle(0, 0, bmpSelectedTile.Width, bmpSelectedTile.Height), ImageLockMode.ReadWrite, PixelFormat.Format32bppArgb);
				TileChunk.nWorkingImage = (byte*) WIData.Scan0.ToPointer();
				for(int nChunk = 0; nChunk < 4; nChunk++){
					if(nTileType == 0){
						nSubtile = G.GetShort(LocForm.L12TileAsm, (TileMap.AreaSelected[0][0][0] << 3) + (nChunk << 1));
						if(nMapType == 0){
							TileChunk.nDecodingStart = (ushort) (((nSubtile & 0x03FF) - 0x0100) << 5);
						}
						else{
							TileChunk.nDecodingStart = (ushort) ((nSubtile & 0x03FF) << 5);
						}
						if(TileChunk.nDecodingStart < 0x6000 + (nMapType * 0x1000)){
							TileChunk.nFlip = (byte) (nSubtile >> 14);
							TileChunk.nPaletteShift = (byte) ((nSubtile & 0x1C00) >> 10);
							TileChunk.dx = (int) ((nChunk & 0x01) << 3);
							TileChunk.dy = (int) ((nChunk & 0x02) << 2);
							TileChunk.PutSubtile();
						}
					}
					else{
						TileMap.AreaSelected[0][0][0] &= 0xFF;
						nSubtile = G.GetShort(LocForm.L3TileAsm, (TileMap.AreaSelected[0][0][0] << 3) + (nChunk << 1));
						TileChunk.nDecodingStart = (ushort) ((nSubtile & 0x03FF) << 4);
						if(TileChunk.nDecodingStart < 0x1000){
							TileChunk.nFlip = (byte) (nSubtile >> 14);
							TileChunk.nPaletteShift = (byte) ((nSubtile & 0x1C00) >> 10);
							TileChunk.dx = (int) ((nChunk & 0x01) << 3);
							TileChunk.dy = (int) ((nChunk & 0x02) << 2);
							TileChunk.PutSubtile();
						}
					}
				}
				bmpSelectedTile.UnlockBits(WIData);
			}

			if(nMapType == 0){
				G.LocPropForm.imgL12SelectedTile.Image = bmpSelectedTile;
				G.LocPropForm.SelectSubtileAsm(nQuad);
			}
			//else{
			//    G.MainForm.OWPropForm.imgL12SelectedTile.Image = bmpSelectedTile;
			//    G.MainForm.OWPropForm.SelectSubtileAsm(nQuad);
			//}
		}

		
		
		public void OnMouseMove(object sender, System.Windows.Forms.MouseEventArgs e) {
			if(G.MainForm.ActiveMdiChild != null){
				if(G.MainForm.ActiveMdiChild.GetType() != typeof(LocationForm) /*&& G.MainForm.ActiveMdiChild.GetType() != typeof(OverworldForm)*/){
					return;
				}

				MouseEventArgs mea = new MouseEventArgs(e.Button, e.Clicks, e.X / G.nZoomFactor, e.Y / G.nZoomFactor, e.Delta);
			
				ushort nMouseTileX = (ushort) (mea.X & 0xFFF0);
				ushort nMouseTileY = (ushort) (mea.Y & 0xFFF0);
			
				if(nMouseTileX == nPrevMouseTileX && nMouseTileY == nPrevMouseTileY){
					return;
				}
			
				// Restore image
				imgTiles.Image = bmpTiles.Clone(new System.Drawing.Rectangle(0, 0, bmpTiles.Width, bmpTiles.Height), bmpTiles.PixelFormat);
				GC.Collect();
				Graphics graphMap = Graphics.FromImage(imgTiles.Image);
				graphMap.CompositingMode = System.Drawing.Drawing2D.CompositingMode.SourceOver;

				cTileMap TileMap = ((MapForm) G.MainForm.ActiveMdiChild).TileMap;

				if(bMouseDown){
					ushort nNewCopyAreaSelectW = 0;
					ushort nNewCopyAreaSelectH = 0;
					ushort nNewCopyAreaSelectX = 0;
					ushort nNewCopyAreaSelectY = 0;
					if(nMouseTileX < TileMap.nCopyAreaSelectX){
						nNewCopyAreaSelectW = (ushort) (TileMap.nCopyAreaSelectX - nMouseTileX);
						nNewCopyAreaSelectX = nMouseTileX;
					}
					else{
						nNewCopyAreaSelectW = (ushort) (nMouseTileX - TileMap.nCopyAreaSelectX);
						nNewCopyAreaSelectX = TileMap.nCopyAreaSelectX;
					}
					if(nMouseTileY < TileMap.nCopyAreaSelectY){
						nNewCopyAreaSelectH = (ushort) (TileMap.nCopyAreaSelectY - nMouseTileY);
						nNewCopyAreaSelectY = nMouseTileY;
					}
					else{
						nNewCopyAreaSelectH = (ushort) (nMouseTileY - TileMap.nCopyAreaSelectY);
						nNewCopyAreaSelectY = TileMap.nCopyAreaSelectY;
					}

					if(nNewCopyAreaSelectW != TileMap.nCopyAreaSelectW || nNewCopyAreaSelectH != TileMap.nCopyAreaSelectH){
						TileMap.nCopyAreaSelectW = nNewCopyAreaSelectW;
						TileMap.nCopyAreaSelectH = nNewCopyAreaSelectH;
						graphMap.FillRectangle(new SolidBrush(System.Drawing.Color.FromArgb(0x20, 255, 255, 255)), nNewCopyAreaSelectX, nNewCopyAreaSelectY, nNewCopyAreaSelectW, nNewCopyAreaSelectH);
					}
				}
				else if(TileMap.AreaSelected != null && !(TileMap.nCopyAreaSelectH == 0 || TileMap.nCopyAreaSelectH > 64 || TileMap.nCopyAreaSelectW == 0 || TileMap.nCopyAreaSelectW > 64)){
					graphMap.FillRectangle(new SolidBrush(System.Drawing.Color.FromArgb(0x20, 255, 255, 255)), nMouseTileX, nMouseTileY, (TileMap.nCopyAreaSelectW << 4), (TileMap.nCopyAreaSelectH << 4));
				}
				else{
					graphMap.FillRectangle(new SolidBrush(System.Drawing.Color.FromArgb(0x20, 255, 255, 255)), nMouseTileX, nMouseTileY, 16, 16);
				}

				imgTiles.Invalidate();
				nPrevMouseTileX = nMouseTileX;
				nPrevMouseTileY = nMouseTileY;
			}
		}



		public void OnMouseDown(object sender, System.Windows.Forms.MouseEventArgs e) {
			MouseEventArgs mea = new MouseEventArgs(e.Button, e.Clicks, e.X / G.nZoomFactor, e.Y / G.nZoomFactor, e.Delta);
			if(G.MainForm.ActiveMdiChild != null){
				if(G.MainForm.ActiveMdiChild.GetType() == typeof(LocationForm) /*|| G.MainForm.ActiveMdiChild.GetType() == typeof(OverworldForm)*/){
					cTileMap TileMap = ((MapForm) G.MainForm.ActiveMdiChild).TileMap;
					bMouseDown = true;
					TileMap.nCopyAreaSelectX = (ushort) (mea.X & 0xFFF0);
					TileMap.nCopyAreaSelectY = (ushort) (mea.Y & 0xFFF0);
					TileMap.nCopyAreaSelectW = 0x10;
					TileMap.nCopyAreaSelectH = 0x10;
				}
			}
		}



		public void OnUpdateZoom(){
			if(bmpTiles == null){
				return;
			}
			imgTiles.Height = (bmpTiles.Height + 4) * G.nZoomFactor;
			imgTiles.Width = (bmpTiles.Width + 4) * G.nZoomFactor;
			imgTiles.Refresh();
		}



		public void SetTiles(Bitmap bmpTilesIn){
			bmpTiles = bmpTilesIn;
			imgTiles.Image = bmpTiles;
			
			if(bmpTiles == null){
				return;
			}

			imgTiles.Size = new Size((bmpTiles.Width + 4) * G.nZoomFactor, (bmpTiles.Height + 4) * G.nZoomFactor);
		}


		public PictureBox GetTiles(){
			return imgTiles;
		}


		
		private void OnResize(object sender, EventArgs e) {
			int nWidth = ClientRectangle.Width;
			int nHeight = ClientRectangle.Height;

			TilesPanel.Width = nWidth - 3;
			TilesPanel.Height = nHeight - 3;
		}
	}
}
